/*
 * RegularChassis.cpp
 *
 *  Created on: Dec 20, 2017
 *      Author: jonah
 */

#include <subsys/regular/RegularChassis.h>

namespace Team302 {

RegularChassis::RegularChassis() :
		IChassis(), //TODO: is this nessesary?
		m_frontLeftMotor(new CANTalon(1)),
		m_frontRightMotor(new CANTalon(0)),
		m_backLeftMotor(new CANTalon(3)),
		m_backRightMotor(new CANTalon(2)),
		m_targetLocationMode(RELATIVE),
		m_movementMode(POWER),
		m_x(0),
		m_y(0),
		m_direction(0),
		m_xTarget(0),
		m_yTarget(0),
		m_directionTarget(0),
		m_pathTravelVelocityTarget(0)

{
	m_frontLeftMotor->SetInverted(true);
	m_backLeftMotor->SetInverted(true);

}

double RegularChassis::GetVelocity() const {
	return 0;
}

double RegularChassis::GetXLocation() const {
	return m_x;
}

double RegularChassis::GetYLocation() const {
	return m_y;
}

double RegularChassis::GetHeading() const {
	return m_direction;
}

IChassis::ChassisType RegularChassis::GetChassisType() const {
	return REGULAR;
}

void RegularChassis::SetTargetLocation(double newTargetX, double newTargetY) {
	m_movementMode = LOCATION;
	m_xTarget = newTargetX;
	m_yTarget = newTargetY;
}

void RegularChassis::SetPathTravelVelocity(double newPathTravelVelocity) {
	m_pathTravelVelocityTarget = newPathTravelVelocity;
}

void RegularChassis::SetTargetLocationMode(IChassis::TargetLocationMode newTargetLocationMode) {
	m_targetLocationMode = newTargetLocationMode;
}

void RegularChassis::SetPowerMagnitudes(double xPower, double yPower, double rotationPower) {
	m_movementMode = POWER; //This method is setting power directly to the motors
	double leftPower = yPower + rotationPower;
	double rightPower = yPower - rotationPower;

	double maxValue = 0;
	if (std::abs(leftPower) > maxValue)
		maxValue = std::abs(leftPower);
	if (std::abs(rightPower) > maxValue)
		maxValue = std::abs(rightPower);

	if (maxValue > 1.0) {
		leftPower /= maxValue;
		rightPower /= maxValue;
	}


	//TODO: change back motors to slave motors
	//Apply motor powers to CANTalons
	m_frontLeftMotor->Set(leftPower);
	m_backLeftMotor->Set(leftPower);
	m_frontRightMotor->Set(rightPower);
	m_backRightMotor->Set(rightPower);
}

void RegularChassis::SetLeftRightPower(double leftPower, double rightPower) {
	m_movementMode = POWER; //This is setting power directly to the motors

		m_frontLeftMotor->Set(leftPower);
		m_backLeftMotor->Set(leftPower);
		m_frontRightMotor->Set(rightPower);
		m_backRightMotor->Set(rightPower);
}

void RegularChassis::UpdateChassis() {
	//update location based on encoder and gyro data

	if (m_movementMode == LOCATION) {
		//do stuff
	}
}

void MecanumChassis::PrintDebug() {
	frc::SmartDashboard::PutNumber("front left vel", m_frontLeftMotor->GetEncVel());
	frc::SmartDashboard::PutNumber("front right vel", m_frontRightMotor->GetEncVel());
	frc::SmartDashboard::PutNumber("back left vel", m_backLeftMotor->GetEncVel());
	frc::SmartDashboard::PutNumber("back right vel", m_backRightMotor->GetEncVel());
}


} /* namespace Team302 */
